#include "main.h"

//
// This shows the l33tness of my 4e3 entry! 
// And it also shows the benefit of hardware programming
//
//  Yours truly,
//           MindWipe

#define MAXBULLETS		256
#define MAXBULLETS2		300
#define STARTYY		-60
int		MAXENEMIES;		
DWORD  MenuBG, MenuLogo, MenuLogoTemp,Cursor,CursorTemp,LoBar,Enem,thing,statt,boss,end;

DWORD LevelBg, Ship, Shot, Sk[7], Bo[3],story,gameover,evs;

#define SHOOTSTART		40
#define SHOOTEND		600
int dam[7];

#define OPI	3.141592653589793f
int lx,ly,lb; //logo cordinates
float dir;

int bl[7];

int		GState, level;
int evil;
bool m;

typedef struct
{
	int x;
	int y;
	int oldy;
	int health;
	char type;
	float d;
	float r;
	bool dead;
}ENEMIES;

ENEMIES E[64];

ENEMIES EVEL;

DWORD	Welcome,Music,begin;


typedef struct
{
	int x;
	int y;
	char type;
	bool used;

}BULLET;

typedef struct
{
	float x;
	float y;
	float sx;
	float sy;
	char type;
	bool used;
	int life;

}BULLET2;

BULLET S[MAXBULLETS];
BULLET2 ES[MAXBULLETS2];

typedef struct
{
	int x;
	int y;
	int hp;
}PLAYER;

PLAYER	P;
int leveltimer;

void InitGame()
{
	COLORKEY ck;

	MAXENEMIES = 4;
	ck.r = 255;
	ck.g = 0;
	ck.b = 255;

	m = false;

	MenuBG = Gfx()->LoadSprite("gfx\\bg.bmp",ck);

	LevelBg = Gfx()->LoadSprite("gfx\\levelbg.bmp",ck); 

	Gfx()->smem = true;
	MenuLogo = Gfx()->LoadSprite("gfx\\logo.bmp",ck);
	Cursor = Gfx()->LoadSprite("gfx\\cursor.bmp",ck);
	ck.r = 0; ck.g = 0; ck.b =0;
	MenuLogoTemp = Gfx()->CreateSprite( 256, 96, ck );
	CursorTemp = Gfx()->CreateSprite( 32, 32, ck );
	story = Gfx()->LoadSprite("gfx\\story.bmp",ck);
		ck.r = 255;
	ck.g = 0;
	ck.b = 255;

	

	gameover = Gfx()->LoadSprite("gfx\\gameover.bmp",ck);
end= Gfx()->LoadSprite("gfx\\theend.bmp",ck);
	Gfx()->smem = false;

	lx = 320 - 128 + cosf(dir) * 128;
	ly = 240 - 48+ sinf(dir) * 96;

	GState = 1;
	Input()->Update();

  	level = 1;

 

	Welcome = Audio()->LoadSound( "audio\\4e3demo.wav" );
	Music = Audio()->LoadSound( "audio\\menumusic.wav" );
	Audio()->SetRepeat( Music, true );

	begin = Audio()->LoadSound( "audio\\letgamebegin.wav" );

	Audio()->PlaySound( Welcome );
	ck.r = 255;
	ck.g = 0;
	ck.b = 255;
	LoBar = Gfx()->LoadSprite("gfx\\lowbar.bmp",ck);

	//game gfx
	Ship = Gfx()->LoadSprite( "gfx\\ship.bmp", ck);
	Shot = Gfx()->LoadSprite( "gfx\\shots.bmp", ck);
 
	Enem= Gfx()->LoadSprite("gfx\\enemies.bmp",ck);

	thing = Gfx()->LoadSprite("gfx\\thing.bmp",ck);
	statt = Gfx()->LoadSprite("gfx\\stat.bmp",ck);
	evs = Gfx()->LoadSprite("gfx\\enemyshots.bmp",ck);
	boss = Gfx()->LoadSprite("gfx\\boss.bmp",ck);

	Sk[0] = Audio()->LoadSound( "audio\\shoot_1.wav" );
	Sk[1] = Audio()->LoadSound( "audio\\shoot_2.wav" );
	Sk[2] = Audio()->LoadSound( "audio\\shoot_3.wav" );
	Sk[3] = Audio()->LoadSound( "audio\\shoot_4.wav" );
	Sk[4] = Audio()->LoadSound( "audio\\shoot_5.wav" );
	Sk[5] = Audio()->LoadSound( "audio\\shoot_6.wav" );
	Sk[6] = Audio()->LoadSound( "audio\\shoot_7.wav" );

	Bo[0] = Audio()->LoadSound( "audio\\boom_1.wav" );
	Bo[1] = Audio()->LoadSound( "audio\\boom_2.wav" );
	Bo[2] = Audio()->LoadSound( "audio\\boom_3.wav" );

	LoadScript( "scripts\\intro.txt" );
	PlayScript();

	P.x = 64;
	P.y = 208;

	for(int i=0;i<MAXBULLETS; i++){ S[i].used = false; S[i].type = 0; }
	for(int v=0;v<MAXBULLETS2; v++){ ES[v].used = false; ES[v].type = 0; }
	//set ammo

	bl[0] = 400;
	bl[1] = 200;
	bl[2] = 300;
	bl[3] = 150;
	bl[4] = 4000;
	bl[5] = 100;
	bl[6] = 50;

	dam[0] = 20;
	dam[1] = 50;
	dam[2] = 80;
	dam[3] = 120;
	dam[4] = 3;
	dam[5] = 150;
	dam[6] = 500;

	for(int b=0; b<MAXENEMIES; b++)
	{
		E[b].oldy  = 48+ rand() % 270;
		E[b].x = 640 + rand() % 640;
		E[b].type = int(rand() % 4);
		E[b].dead = false;
		
		E[b].d = (rand() % 6283) / 1000;

		if( E[b].type == 0) E[b].health = 300;
		if( E[b].type == 1) E[b].health = 225;
		if( E[b].type == 2) E[b].health = 375;
		if( E[b].type == 3) E[b].health = 450;
	}
	
	EVEL.health = 50000;
	EVEL.x = 900;
	EVEL.y = STARTYY;
	EVEL.r = 1.0f;
	EVEL.d = 0.0f;
	P.hp = 1000;

	evil =0; //we're all nice

	SHOW_FPS = false;


	//little cheat
		Input()->Update();
	if(Input()->KeyDown(DIK_G)) level = 2;
}

int FindB()
{
	for(int i=0;i<MAXBULLETS;i++)
		if(!S[i].used) return i;

		return 999;
}

int FindB2()
{
	for(int i=0;i<MAXBULLETS2;i++)
		if(!ES[i].used) return i;

		return 999;
}


void MoveBullets()
{
	for(int i=0;i<MAXBULLETS;i++)
	{
		if(S[i].used)
		{
			if(S[i].type == 1)	S[i].x +=8;
			if(S[i].type == 2)	S[i].x +=6;
			if(S[i].type == 3)	S[i].x +=7;
			if(S[i].type == 4)	S[i].x +=4;
			if(S[i].type == 5)	S[i].x +=9;
			if(S[i].type == 6)	S[i].x +=3;
			if(S[i].type == 7)	S[i].x +=5;
	
			if(S[i].x > 640 - 16) S[i].used = false;
		}
	}
}


void EVELMoveBullets()
{
	for(int i=0;i<MAXBULLETS2;i++)
	{
		if(ES[i].used)
		{
			ES[i].x+=ES[i].sx;
			ES[i].y+=ES[i].sy;
	
			ES[i].life--;

			if(ES[i].life < 0) ES[i].used = false;
			if(ES[i].x < 0) ES[i].used = false;
			if(ES[i].y < 0 ) ES[i].used = false;
			if(ES[i].y > 480 - 16) ES[i].used = false;
		}
	}
}

void ShootBullet( char type )
{
	int bul;
	
	bul = FindB();

	if(bul == 999) return;

	if(bl[type-1] > 0) 
		bl[type-1]--;
	else return;

	if(type == 1)
	{
	

		S[bul].x = P.x + 30;
		S[bul].y = P.y + 18;

		Audio()->PlaySound( Sk[1] );
	}

	if(type == 2)
	{
		S[bul].x = P.x + 51;
		S[bul].y = P.y + 9;
		Audio()->PlaySound( Sk[2] );
	}
	
	if(type == 3)
	{
		S[bul].x = P.x + 40;
		S[bul].y = P.y + 35;
		Audio()->PlaySound( Sk[4] );
	}
	
	if(type == 4)
	{
		S[bul].x = P.x + 55;
		S[bul].y = P.y + 55;
		Audio()->PlaySound( Sk[6] );
	}
	
	if(type == 5)
	{
		S[bul].x = P.x + 44;
		S[bul].y = P.y + 3;
		Audio()->PlaySound( Sk[3] );
	}
	
	if(type == 6)
	{
		S[bul].x = P.x + 61;
		S[bul].y = P.y + 43;
		Audio()->PlaySound( Sk[0] );
	}

	if(type == 7)
	{
		S[bul].x = P.x + 54;
		S[bul].y = P.y + 28;
		Audio()->PlaySound( Sk[5] );
	}

	S[bul].used = true;
	S[bul].type = type;
}

void ShootBullet2( char type )
{
	int bul;
	float gh;

	bul = FindB2();

	if(bul == 999) return;

	//WATER
	if(type == 1)
	{	ES[bul].x = EVEL.x + 20;
		ES[bul].y = EVEL.y + 344;

		ES[bul].life = 250;
		ES[bul].sx = -3;
		ES[bul].sy = -0.5f;
	}

	//FIRE
	if(type == 4)
	{
	
		ES[bul].x = EVEL.x + 20;
		ES[bul].y = EVEL.y + 330;
		ES[bul].life = 220;
		gh = float(rand() % (3141/2)) / 1000.0f;
		ES[bul].sx = -sinf(gh+0.7853f)*2;
		ES[bul].sy = cosf(gh+0.7853f) - 1;

	}

	//WIND
	if(type == 2)
	{
			ES[bul].x = EVEL.x + 20;
		ES[bul].y = EVEL.y + 375;
		ES[bul].life = 120;
		gh = float(rand() % (3141/3)) / 1000.0f;
		ES[bul].sx = -sinf(gh+1.047f)*3;
		ES[bul].sy = cosf(gh+1.047f)-1;
	}
	
	//EARTH
	if(type == 3)
	{
		ES[bul].x = EVEL.x + 20;
		ES[bul].y = EVEL.y + 361;
	
		ES[bul].life = 150;
		gh = float(rand() % (3141/2)) / 1000.0f;
		ES[bul].sx = -sinf(gh)*4;
		ES[bul].sy = cosf(gh)-1.5f;
	}
	
 

	ES[bul].used = true;
	ES[bul].type = type;
}

void DrawBullets()
{
	RECT rc;


	for(int i=0;i<MAXBULLETS;i++)
	{
		if(S[i].used)
		{
			if(S[i].type == 1) SetRect(&rc, 0,0,8,8);
			if(S[i].type == 2) SetRect(&rc, 8,0,16,8);
			if(S[i].type == 3) SetRect(&rc, 16,0,24,8);
			if(S[i].type == 4) SetRect(&rc, 24,0,32,8);
			if(S[i].type == 5) SetRect(&rc, 0,8,8,16);
			if(S[i].type == 6) SetRect(&rc, 8,8,16,16);
			if(S[i].type == 7) SetRect(&rc, 16,8,32,16);

			Gfx()->Blit( S[i].x, S[i].y, Shot, &rc);
		}
	}
}

void EVELDrawBullets()
{
	RECT rc;


	for(int i=0;i<MAXBULLETS2;i++)
	{
		if(ES[i].used)
		{
			if(ES[i].type == 1) SetRect(&rc, 0,0,16,16);
			if(ES[i].type == 2) SetRect(&rc, 16,0,32,16);
			if(ES[i].type == 3) SetRect(&rc, 0,16,16,32);
			if(ES[i].type == 4) SetRect(&rc, 16,16,32,32);
		
			Gfx()->Blit( ES[i].x, ES[i].y, evs, &rc);
		}
	}
}

void MenuLoop()
{
	static DWORD OldTime;
	RECT rc;

	Input()->Update();

	if(Input()->sMouse.button[0])
	{
		if(Input()->sMouse.x > 270 && Input()->sMouse.x < 365 &&
		Input()->sMouse.y > 200 && Input()->sMouse.y < 262	)
		{
		GState = 3;

		}
	}
	if( GetTickCount() - OldTime > 1000 / 50 )
	{
		OldTime = GetTickCount();
		
		dir += 0.02f;

		if(dir > 6.283)
		{
			dir = 0;
			if(!m){
			Audio()->PlayPrimarySound( Music );
			m = true;
			}
		}
	
		lx = 320 - 128 + cosf(dir) * 128;
		ly = 240 - 48 + sinf(dir) * 96;
	}

	Gfx()->OpaqueBlit(0,0,MenuBG,NULL);

	
	SetRect( &rc, lx, ly, lx + 256, ly + 96 );
	Gfx()->MMXEffectBlit( 0, 0, MenuLogoTemp,MenuBG, &rc, E_RED ); 
	Gfx()->BlitTwo(0,0, MenuLogoTemp, MenuLogo, NULL);
	Gfx()->Blit(lx,ly,MenuLogoTemp,NULL);

	SetRect( &rc, Input()->sMouse.x , Input()->sMouse.y, Input()->sMouse.x + 32, Input()->sMouse.y + 32 );
	Gfx()->MMXEffectBlit( 0, 0, CursorTemp,MenuBG, &rc, E_INVERT ); 
	Gfx()->BlitTwo(0,0, CursorTemp, Cursor, NULL);
	Gfx()->Blit(Input()->sMouse.x , Input()->sMouse.y,CursorTemp,NULL);
 	DoScript();

	FontWrite( 240, 12, "NO HARDWARE ACCELERATION USED!!!");

}

bool CheckCollision( int x, int y, int width, int height) //with player
{
	if(width == 1 && height == 1)
		if( x > P.x + 4 && x < P.x + 59 && y > P.y + 14 && y < P.y + 49 )
			return true;
		else
			return false;
		
	if( x > P.x + 4 && x < P.x + 59 && y > P.y + 14 && y < P.y + 49 ) return true;
	if( x + width > P.x + 4 && x + width < P.x + 59 && y > P.y + 14 && y < P.y + 49 ) return true;
	if( x > P.x + 4 && x < P.x + 59 && y + height > P.y + 14 && y + height < P.y + 49 ) return true;
	if( x + width > P.x + 4 && x + width < P.x + 59 && y + height > P.y + 14 && y + height < P.y + 49 ) return true;
	
	return false;
}
void MoveEnemies()
{


	for(int i=0; i<MAXENEMIES; i++)
	{
		if(!E[i].dead)
		{
			E[i].x--;
			
			E[i].d+=0.05;
			
			E[i].y= E[i].oldy + sinf(E[i].d)*16;
			
			
			if(CheckCollision( E[i].x + 5, E[i].y + 5, 54,54 ))
			{
				Audio()->PlaySound( Bo[int(rand()%3)] );
				P.hp-= 50 + int(rand() % 50);
				E[i].dead = true;
			}
		}
		else{ E[i].y++;	E[i].x--; }

		if(E[i].x<40 || E[i].y > 410)
		{
			if(!E[i].dead)
			{
			if(E[i].type == 0) evil+=4;
			if(E[i].type == 1) evil+=3;
			if(E[i].type == 2) evil+=5;
			if(E[i].type == 3) evil+=6;
			}

			E[i].oldy  = 48+ rand() % 270;
			E[i].x = 640 + rand() % 200;
			E[i].type = rand() % 4;
			E[i].dead = false;
	
		 

		E[i].d = (rand() % 6283) / 1000;

		if( E[i].type == 0) E[i].health = 300;
		if( E[i].type == 1) E[i].health = 225;
		if( E[i].type == 2) E[i].health = 375;
		if( E[i].type == 3) E[i].health = 450;
		}
		
	}
}
 

void CheckBullets()
{
	for(int i=0;i<MAXBULLETS;i++)
		if(S[i].used)
		 for(int b=0;b<MAXENEMIES;b++)
		 {
			 if(!E[b].dead) 
			 if( S[i].x > (E[b].x + 5) && S[i].x < (E[b].x + 59) &&
				 S[i].y > (E[b].y + 5) && S[i].y < (E[b].y + 59))
			 {

				 S[i].used = false;
				if(S[i].type != 5) Audio()->PlaySound( Bo[int(rand()%3)] );
				 E[b].health -= dam[S[i].type-1];

				 if(E[b].health < 0)	E[b].dead = true;
			 }
		 }
}
void CheckBullets2()
{
	for(int i=0;i<MAXBULLETS;i++)
		if(S[i].used)
			 if( S[i].x > (EVEL.x + 50) && S[i].x < (EVEL.x + 166) &&
				 S[i].y > (EVEL.y + 120) && S[i].y < (EVEL.y + 266))
			 {

				 S[i].used = false;
				 if(S[i].type != 5) Audio()->PlaySound( Bo[int(rand()%3)] );
				 EVEL.health -= dam[S[i].type-1];

			 }
}


void EVELCheckBullets()
{
	for(int i=0;i<MAXBULLETS2;i++)
		if(ES[i].used)
			 if( ES[i].x > (P.x + 4) && ES[i].x < (P.x + 50) &&
				 ES[i].y > (P.y + 14) && ES[i].y < (P.y + 48))
			 {

				 ES[i].used = false;
				 Audio()->PlaySound( Bo[int(rand()%3)] );
			
				 if( ES[i].type == 1) P.hp -= 5;
				 if( ES[i].type == 2) P.hp -= 10;
				 if( ES[i].type == 3) P.hp -= 15;
				 if( ES[i].type == 4) P.hp -= 20;
				 
				 

				 if(P.hp < 0) GState = 666;
			 }
	
}
void DrawEnemies()
{
	RECT rc;
	for(int i=0; i<MAXENEMIES; i++)
	{
		
		if(E[i].x<640-64)
		{
			if(!E[i].dead)	SetRect(&rc,E[i].type * 64, 0, E[i].type * 64 + 64, 128);
				else SetRect(&rc,E[i].type * 64, 128, E[i].type * 64 + 64, 192);
			Gfx()->Blit( E[i].x, E[i].y, Enem, &rc);
			
		}
	}
}

void MoveEVEL()
{
	static int mstate = 0;
	static int time = 0;
	static char sk;
	time++;

	if(EVEL.x > 800) mstate = 10;

	if( mstate == 10 ) 
	{
		EVEL.x-=2;

		if(EVEL.x < 370 ){ time = 0; mstate = 1; sk = int(rand() % 4) + 1; }
		return;
	}


	if( mstate == 0 )
	{
		if(time > SHOOTSTART && time < SHOOTEND) 	ShootBullet2(sk); 
		if( time < 100)
		{
			EVEL.y--;
		}
	 
		if( time > 300)
		{
			EVEL.y++;
			if(EVEL.y>STARTYY){EVEL.y = STARTYY; mstate = int(rand() % 5); time = 0;  sk = int(rand() % 4) + 1;}
		}
	}
	// Go Slow Up / Down
	if( mstate == 1 )
	{
		if(time > SHOOTSTART && time < SHOOTEND) 	ShootBullet2(sk); 
		if(time < 150)
		{
		EVEL.d += 0.02f;
	
		if(EVEL.d > OPI*2) EVEL.d = 0.0f;
	
		EVEL.r += 1.0f;
		EVEL.y = STARTYY + sinf(EVEL.d) * EVEL.r;

		}
		if(time > 150 && time < 500)
		{
		 
			EVEL.d += 0.02f;
			if(EVEL.d > OPI*2) EVEL.d = 0.0f;
			EVEL.y = STARTYY + sinf(EVEL.d) * EVEL.r;
		}

		if(time > 500)
		{
			EVEL.r-=1.0f;
			if(EVEL.r < 0){ EVEL.r = 0.0f; mstate = int(rand() % 5); time = 0; sk = int(rand() % 4) + 1; }

			EVEL.d += 0.02f;
				if(EVEL.d > OPI*2) EVEL.d = 0.0f;
			EVEL.y = STARTYY + sinf(EVEL.d) * EVEL.r;
		}
	}

	// Go slow forward/backward
	if( mstate == 2 )
	{
		if(time > SHOOTSTART && time < SHOOTEND) 	ShootBullet2(sk); 
		if(time < 150)
		{
		EVEL.d += 0.03f;
	
		if(EVEL.d > OPI*2) EVEL.d = 0.0f;
	
		EVEL.r += 1.0f;
		EVEL.x = 370 + sinf(EVEL.d) * EVEL.r;
		EVEL.y = STARTYY - EVEL.r;
		}
		if(time > 150 && time < 500)
		{
 
			EVEL.d += 0.03f;
			if(EVEL.d > OPI*2) EVEL.d = 0.0f;
			EVEL.x = 370 + sinf(EVEL.d) * EVEL.r;
		}

		if(time > 500)
		{
			EVEL.r-=1.0f;

			EVEL.y=STARTYY - EVEL.r;
			if(EVEL.r < 0){ EVEL.y =STARTYY; EVEL.r = 0.0f; mstate = int(rand() % 5); time = 0; sk = int(rand() % 4) + 1; }

			EVEL.d += 0.03f;
				if(EVEL.d > OPI*2) EVEL.d = 0.0f;
			EVEL.x = 370 + sinf(EVEL.d) * EVEL.r;
		}
	}

	// GO Fast Round
	if( mstate == 3 )
	{
		if(time > SHOOTSTART && time < SHOOTEND) 	ShootBullet2(sk); 
		if(time < 150)
		{
		EVEL.d += 0.1f;
	
		if(EVEL.d > OPI*2) EVEL.d = 0.0f;
	
		EVEL.r += 1.0f;

		EVEL.x = 370 + cosf(EVEL.d) * EVEL.r;
		EVEL.y = STARTYY + sinf(EVEL.d) * EVEL.r;

		}
		if(time > 150 && time < 500)
		{
	 
				EVEL.d += 0.1f;
	
			if(EVEL.d > OPI*2) EVEL.d = 0.0f;
			EVEL.x = 370 + cosf(EVEL.d) * EVEL.r;
			EVEL.y = STARTYY + sinf(EVEL.d) * EVEL.r;
		}

		if(time > 500)
		{
			EVEL.r-=1.0f;

			if(EVEL.r < 0){ EVEL.r = 0.0f; mstate = int(rand() % 5); time = 0;  sk = int(rand() % 4) + 1;}

			EVEL.d += 0.1f;
	
			if(EVEL.d > OPI*2) EVEL.d = 0.0f;
			EVEL.x = 370 + cosf(EVEL.d) * EVEL.r;
			EVEL.y = STARTYY + sinf(EVEL.d) * EVEL.r;
		}
	}

	if( mstate == 4 )
	{
		if(time > SHOOTSTART && time < SHOOTEND) 	ShootBullet2(sk); 
		if(time < 150)
		{
		EVEL.d += 0.05f;
	
		if(EVEL.d > OPI*2) EVEL.d = 0.0f;
	
		EVEL.r += 0.6f;

		EVEL.x = 370 + cosf(EVEL.d) * EVEL.r;
		EVEL.y = STARTYY + sinf(EVEL.d) * EVEL.r;

		}
		if(time > 150 && time < 500)
		{
		 
				EVEL.d +=  0.05f;
	
			if(EVEL.d > OPI*2) EVEL.d = 0.0f;
			EVEL.x = 370 + cosf(EVEL.d) * EVEL.r;
			EVEL.y = STARTYY + sinf(EVEL.d) * EVEL.r;
		}

		if(time > 500)
		{
			EVEL.r-=1.0f;

			if(EVEL.r < 0){ EVEL.r = 0.0f; mstate = int(rand() % 5); time = 0; sk = int(rand() % 4) + 1;}

			EVEL.d +=  0.05f;
	
			if(EVEL.d > OPI*2) EVEL.d = 0.0f;
			EVEL.x = 370 + cosf(EVEL.d) * EVEL.r;
			EVEL.y = STARTYY + sinf(EVEL.d) * EVEL.r;
		}
	}


}

	void GameLoop()
{	
	static DWORD OldTime = 0;
	static DWORD OldTime2 = 0;
	static DWORD OldTime3 = 0;
	static bool first = false;
	static bool first2 = false;
		static bool first3 = false;
	static bool ns = false;
	static int sss = 0;
	RECT rc;

	char Stat[3][128];

	if(GState == 1)
	{
		SHOW_FPS = false;
		MenuLoop();
					if(Input()->KeyDown( DIK_ESCAPE )) alive = false;
	}
	if(GState == 3)
	{
		SHOW_FPS = false;
		if(!first)
		{
					Audio()->PlayPrimarySound( Music );
		first=true;
		}
		Input()->Update();
		Gfx()->Blit(0,0,story,NULL);
		if( Input()->KeyDown(DIK_RETURN) )
		{
				Audio()->PlaySound( begin );
			GState = 3;
			Audio()->StopSound( Music );

			Audio()->ReleaseSound( Music );
			Music = Audio()->LoadSound( "audio\\music.wav" );
			Audio()->SetRepeat( Music, true );
			Audio()->PlayPrimarySound( Music );

			leveltimer = 13000;
			GState = 2;

		}
	}
	if(GState == 666)
	{
		SHOW_FPS = false;
		if(!first2)
		{
			Audio()->StopSound( Music );

			Audio()->ReleaseSound( Music );
			Music = Audio()->LoadSound( "audio\\menumusic.wav" );
			Audio()->SetRepeat( Music, true );
			Audio()->PlayPrimarySound( Music );
		first2=true;
		}
		Input()->Update();
		Gfx()->Blit(0,0,gameover,NULL);
		if( Input()->KeyDown(DIK_ESCAPE) )
		{
			alive = false;
		}
	}

	if(GState == 55)
	{
			SHOW_FPS = false;
		if(!first2)
		{
			Audio()->StopSound( Music );

			Audio()->ReleaseSound( Music );
			Music = Audio()->LoadSound( "audio\\menumusic.wav" );
			Audio()->SetRepeat( Music, true );
			Audio()->PlayPrimarySound( Music );
		first2=true;
		}
		Input()->Update();
		Gfx()->Blit(0,0,end,NULL);
		if( Input()->KeyDown(DIK_ESCAPE) )
		{
			alive = false;
		}
	}
	if(GState == 2)
	{
	SHOW_FPS = true;
		//Everything that need a stable speed (scrolling, input)
		if( GetTickCount() - OldTime > 1000 / 50 )
		{
		OldTime = GetTickCount();
		lb++; if(lb>640)lb=0;

			Input()->Update();
		
			if(Input()->KeyDown( DIK_DOWN ) && P.y < 415) P.y+=3;
			if(Input()->KeyDown( DIK_UP ) && P.y > 5) P.y-=3;
			if(Input()->KeyDown( DIK_LEFT ) && P.x > 48) P.x-=3;
			if(Input()->KeyDown( DIK_RIGHT ) && P.x < 220) P.x+=3;

			if(Input()->KeyPressed( DIK_1 )) ShootBullet( 1 );
			if(Input()->KeyPressed( DIK_2 )) ShootBullet( 2 );
			if(Input()->KeyPressed( DIK_3 )) ShootBullet( 3 );
			if(Input()->KeyPressed( DIK_4 )) ShootBullet( 4 );
			if(Input()->KeyDown( DIK_5 )) ShootBullet( 5 );
			if(Input()->KeyPressed( DIK_6 )) ShootBullet( 6 );
			if(Input()->KeyPressed( DIK_7 )) ShootBullet( 7 );

			if(Input()->KeyDown( DIK_ESCAPE )) alive = false;
		 

		}
 

		if(level == 1)
		{
				if( GetTickCount() - OldTime2 > 1000 / 50 )
		{
		OldTime2 = GetTickCount();
			MoveBullets();
			MoveEnemies();
	
					CheckBullets();

			leveltimer--;

			if(leveltimer==14000){ MAXENEMIES+=1; ns=true;}
			if(leveltimer==13500){ MAXENEMIES+=1; ns=true;}
			if(leveltimer==12000){ MAXENEMIES+=1; ns=true;}
			if(leveltimer==11500){ MAXENEMIES+=1; ns=true;}	
			if(leveltimer==9000){ MAXENEMIES+=1; ns=true;}
			if(leveltimer==8999){ MAXENEMIES+=1; ns=true;}
			if(leveltimer==8600){ MAXENEMIES+=1; ns=true;}	
			if(leveltimer==6600){ MAXENEMIES+=1; ns=true;}	
			if(leveltimer==6000){ MAXENEMIES+=1; ns=true;}
			if(leveltimer==5000){ MAXENEMIES+=1; ns=true;}
			if(leveltimer==4000){ MAXENEMIES+=1; ns=true;}
			if(leveltimer==3000){ MAXENEMIES+=1; ns=true;}
			if(leveltimer==2000){ MAXENEMIES+=1; ns=true;}
			

			sss = (1.0f -(float(leveltimer) / 13000.0f) ) * 80;
		
			if(ns)
			{

			E[MAXENEMIES-1].oldy  = 48+ rand() % 270;
			E[MAXENEMIES-1].x = 640 + rand() % 200;
			E[MAXENEMIES-1].type = rand() % 4;
			E[MAXENEMIES-1].dead = false;
	
		 
			
		E[MAXENEMIES-1].d = (rand() % 6283) / 1000;

		if( E[MAXENEMIES-1].type == 0) E[MAXENEMIES-1].health = 300;
		if( E[MAXENEMIES-1].type == 1) E[MAXENEMIES-1].health = 225;
		if( E[MAXENEMIES-1].type == 2) E[MAXENEMIES-1].health = 375;
		if( E[MAXENEMIES-1].type == 3) E[MAXENEMIES-1].health = 450;
			}

			if(leveltimer<0) level=2;
				}
		SetRect(&rc, lb,0,640,416);
		Gfx()->Blit(0,0,LevelBg,&rc);
	
		SetRect(&rc, 0,0,lb,416);
		Gfx()->Blit(640-lb,0,LevelBg,&rc);

		 
		Gfx()->Blit( P.x, P.y, Ship, NULL);


		DrawEnemies();
		DrawBullets();
		Gfx()->Blit( 640-64, 0, thing, NULL);
		Gfx()->Blit( 0, 416, LoBar, NULL);

		SetRect( &rc, 0, 8, 100, 32 );
		Gfx()->Blit( 520, 430, statt, &rc);

		SetRect( &rc, 3, 1, 10, 6 );
		Gfx()->Blit( 530 + sss, 442, statt, &rc);

		memset(Stat[0],0,sizeof(char) * 128);
		memset(Stat[1],0,sizeof(char) * 128);
		memset(Stat[2],0,sizeof(char) * 128);


		sprintf(Stat[0],"1= %d, 2= %d, 3= %d, 4= %d",
				bl[0], bl[1], bl[2], bl[3]);
	
		sprintf(Stat[1],"5= %d, 6= %d, 7= %d",
				bl[4], bl[5], bl[6]);

		sprintf(Stat[2],"Hp: %d Evilness: %d / 100",P.hp,evil);

		FontWrite(32, 430, Stat[0]);
		FontWrite(32, 450, Stat[1]);

 
		FontWrite(170, 5, Stat[2]);

		if(P.hp <= 0) GState = 666;
		if(evil >= 100) GState = 666;

		}
		
		if(level == 2)
		{	
	
			Audio()->StopSound( Music );

			Audio()->ReleaseSound( Music );
			Music = Audio()->LoadSound( "audio\\music2.wav" );
			Audio()->SetRepeat( Music, true );
			Audio()->PlayPrimarySound( Music );

			bl[0] = 400;
			bl[1] = 200;
			bl[2] = 300;
			bl[3] = 150;
			bl[4] = 4000;
			bl[5] = 100;
			bl[6] = 50;
			
			P.hp = 1000;
			level = 3;

		}

		if(level == 3)
		{

			if( GetTickCount() - OldTime3 > 1000 / 50 )
			{
					OldTime3 = GetTickCount();
					
				 

						MoveBullets();
					CheckBullets2();

					MoveEVEL();
					 EVELCheckBullets();
	

			

			 	EVELMoveBullets();
					
					if(CheckCollision( EVEL.x + 60, EVEL.y + 100, 110, 280))
					{
						P.hp-=3;
					}

					if(EVEL.health < 0) GState = 55;
	
			}
				int th;
				SetRect(&rc, lb,0,640,416);
					Gfx()->Blit(0,0,LevelBg,&rc);
	
					SetRect(&rc, 0,0,lb,416);
					Gfx()->Blit(640-lb,0,LevelBg,&rc);

		 
					Gfx()->Blit( P.x, P.y, Ship, NULL);

					SetRect(&rc,0,0,250,400);
				
					th =0;
					if(EVEL.x + 250 > 640) rc.right =  250 - ((EVEL.x + 250) - 640);
					if(EVEL.y + 400 > 480) rc.bottom =  400 - ((EVEL.y + 400) - 480);
					if(EVEL.y < 0){ rc.top = -EVEL.y; th = -EVEL.y; }
					Gfx()->Blit( EVEL.x, EVEL.y+th, boss, &rc);

				
					DrawBullets();
					EVELDrawBullets();

	Gfx()->Blit( 0, 416, LoBar, NULL);
				memset(Stat[0],0,sizeof(char) * 128);
		memset(Stat[1],0,sizeof(char) * 128);
		memset(Stat[2],0,sizeof(char) * 128);


		sprintf(Stat[0],"1= %d, 2= %d, 3= %d, 4= %d",
				bl[0], bl[1], bl[2], bl[3]);
	
		sprintf(Stat[1],"5= %d, 6= %d, 7= %d",
				bl[4], bl[5], bl[6]);

		sprintf(Stat[2],"Hp: %d Boss Hp: %d / 50000",P.hp,EVEL.health);

		FontWrite(32, 430, Stat[0]);
		FontWrite(32, 450, Stat[1]);

 
		FontWrite(150, 5, Stat[2]);

		}
	}

}